<template>
  <div :class="`api-data ${progress ? 'progress' : ''}`">
    <div class="lds-ring">
      <div></div>
      <div></div>
      <div></div>
      <div></div>
    </div>
  </div>
</template>

<script>
export default {
  name: "ApiData",
  mounted() {
    this.load();
    if (this.interval !== null) {
      setTimeout(this.loadOnInterval, this.pollInterval);
    }
  },
  data() {
    return {
      progress: false,
      subsequentialErrors: 0,
    };
  },
  methods: {
    loadOnInterval() {
      this.load();
      if (this.interval !== null) {
        setTimeout(this.loadOnInterval, this.pollInterval);
      }
    },
    load() {
      const url = `${this.apiUrl}${this.endpoint}`;
      if (!this.invisible) this.progress = true;
      import("axios").then(({ default: axios }) => {
        axios.interceptors.response.use(
          (response) => response,
          (error) => {
            if (error.response.status === 401) {
              if (window.location.pathname !== "/flowui-login/") {
                window.location.href =
                  "/flowui-login/?next=" + window.location.pathname;
              }
            }

            if (typeof error.response === "undefined") {
              this.notify(
                "A network error occurred. " +
                  "This could be a CORS issue or a dropped internet connection. " +
                  "It is not possible for us to know.",
                "Network error",
                "error"
              );
            }
            return Promise.reject(error);
          }
        );
        axios
          .get(url, { withCredentials: true })
          .then((response) => {
            this.subsequentialErrors = 0;
            this.$emit("update:modelValue", response.data);
            this.$emit("success", response);
          })
          .catch((error) => {
            this.subsequentialErrors += 1;
            this.notify(error, error.name, "error");
            this.$emit("failure", error);
          })
          .finally(() => (this.progress = false));
      });
    },
  },
  props: {
    modelValue: {
      type: Object,
      default: () => {},
    },
    endpoint: {
      type: String,
    },
    interval: {
      type: Number,
      default: null,
    },
    invisible: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    pollInterval: {
      get() {
        if (!this.interval) return null;
        if (this.subsequentialErrors) {
          // Postpone every next interval by another 2 seconds on subsequential errors
          return this.interval + 2000 * this.subsequentialErrors;
        }
        return this.interval;
      },
    },
  },
};
</script>

<style lang="scss">
div.api-data {
  display: none;
  position: fixed;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
  background: rgba(0, 0, 0, 0.3);
  z-index: 10000;
  &.progress {
    display: grid;
    place-items: center;
  }
}
.lds-ring {
  display: inline-block;
  position: relative;
  width: 80px;
  height: 80px;
}
.lds-ring div {
  box-sizing: border-box;
  display: block;
  position: absolute;
  width: 64px;
  height: 64px;
  margin: 8px;
  border: 8px solid #fff;
  border-radius: 50%;
  animation: lds-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;
  border-color: #fff transparent transparent transparent;
}
.lds-ring div:nth-child(1) {
  animation-delay: -0.45s;
}
.lds-ring div:nth-child(2) {
  animation-delay: -0.3s;
}
.lds-ring div:nth-child(3) {
  animation-delay: -0.15s;
}
@keyframes lds-ring {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}
</style>
